﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;

namespace Hexapod
{
    class HeadorTail
    {
        public IntVector Orientation = new IntVector( 0, 0, 0 );

        public int Mass;
        public string Type;
        private int CGdist;
        public IntVector Offset;

        public HeadorTailServoAngles Angles;
        public HeadorTailServoValues Values;

        public HeadorTail(string type, int cgdist, int mass)
        {
            Type = type;
            CGdist = cgdist;
            Mass = mass;
            DoubleVector CGpos = new DoubleVector(0, -CGdist, 0);
            IntVector Rotation = new IntVector(Convert.ToInt16(Angles.Tilt), 0, Convert.ToInt16(Angles.Pan));
            CGpos = CGpos.Rotate(Rotation);
        }

        public void Update()
        {
            Values = Angles.ConvertToServoValues();
        }
    }
}
