﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Robomnia_1._0
{
    
    public partial class HexapodForm : Form
    {
        Sensors.Rangefinder rangefinder = new Sensors.Rangefinder();
        Sensors.Battery battery = new Sensors.Battery();
        Hexapod.Body theRobot = new Hexapod.Body();        
        double Direction;
        SamsungMobileSdk.MyOrientation.Vector vector = new SamsungMobileSdk.MyOrientation.Vector();
        System.Diagnostics.Stopwatch watch = new System.Diagnostics.Stopwatch();

        public HexapodForm()
        {
            InitializeComponent();
        }

        private Hexapod.IntVector DecideRotation()
        {
            Hexapod.IntVector rotation = new Hexapod.IntVector(0,0,0);
            int maxval = 30;
            if (menuRotation.Checked)
            {
                rotation.X = - vector.pitch;
                rotation.Y = - vector.roll;
                rotation.Z = 0;

                if (rotation.X < (-1* maxval))
                {
                    rotation.X = (-1* maxval);
                }
                else if (rotation.X > maxval)
                {
                    rotation.X = maxval;
                }

                if (rotation.Y < (-1* maxval))
                {
                    rotation.Y = (-1* maxval);
                }
                else if (rotation.Y > maxval)
                {
                    rotation.Y = maxval;
                }
            }
            else
            {
                rotation.X = Convert.ToInt16(-1*XRupdown.Value);
                rotation.Y = Convert.ToInt16(-1*YRupdown.Value);
                rotation.Z = Convert.ToInt16(ZRupdown.Value);
            }
            return rotation;

        }

        private void menuItem1_Click(object sender, EventArgs e)
        {
            timer1.Enabled = false;
            this.Dispose();
        }

        private void ControlsToParameters() //Updates the hexapod with values from the form controls
        {
            vector = Sensors.Sensors.GetOrientation(); 
            theRobot.speed = Convert.ToInt16(Speedupdown.Value); //get the speed
            theRobot.BodyRotation = DecideRotation();
            Hexapod.IntVector shift = new Hexapod.IntVector( Convert.ToInt16(XSupdown.Value), Convert.ToInt16(YSupdown.Value), Convert.ToInt16(ZSupdown.Value) );
            theRobot.BodyShift = shift;
            theRobot.stepheight = 20;
            theRobot.gaitdirection = Convert.ToInt16(gaitDirectionupdown.Value);
                              
            switch (gaitBox1.SelectedItem.ToString())  //get the right gait
            {
                case "None":
                    theRobot.gait = Hexapod.GaitType.None;
                    break;
                case "Tripod":
                    theRobot.gait = Hexapod.GaitType.Tripod;
                    break;
                case "Two Leg Ripple":
                    theRobot.gait = Hexapod.GaitType.TwoLegRipple;
                    break;
                case "Four Leg":
                    theRobot.gait = Hexapod.GaitType.FourLeg;
                    break;
                case "One Leg Ripple":
                    theRobot.gait = Hexapod.GaitType.OneLegRipple;
                    break;
            }
            theRobot.gaitrotation = Convert.ToInt16(gaitRotationupdown.Value);                   //get the rotation
            if (theRobot.gait == Hexapod.GaitType.None)
            {
                theRobot.gaitrotation = 0;
            } 
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            int IKinterval = 300 - (theRobot.speed * 2);                    //this is used as the length of time the servos have to move from old to new position
                ControlsToParameters();

                if (theRobot.speed == 0 && theRobot.gaitrotation == 0)
                {
                    IKinterval = 100; //as rapid as possible
                }
            theRobot.Update(IKinterval);
            //if (theRobot.updated)
            {
                rangefinder.Update();
            }
            watch.Stop();
            int Sleeptime = Convert.ToInt16(IKinterval - 80);//watch.ElapsedMilliseconds);
            if (Sleeptime < 0)
            {
                Sleeptime = 0;
            }

            System.Threading.Thread.Sleep(Sleeptime);

            watch.Reset();
            watch.Start();
            
        }

        private void HexapodForm_Load(object sender, EventArgs e)
        {
            gaitBox1.SelectedItem = "None";
            bool portopened = Bluetooth.BluetoothFunctions.ConnectMaestro();
            if (!portopened)
            {
                MessageBox.Show("Problem opening the Bluetooth serial port!");
            }
            else
            {
            }
        }

        private void gaitDirectionupdown_ValueChanged(object sender, EventArgs e)
        {
            if (gaitDirectionupdown.Value == -1)
            {
                gaitDirectionupdown.Value = 359;
            }
            else if (gaitDirectionupdown.Value == 360)
            {
                gaitDirectionupdown.Value = 0;
            }
            Direction = Convert.ToDouble(gaitDirectionupdown.Value);
        }

        private void menuNone_Click(object sender, EventArgs e)
        {
            if (!menuNone.Checked)
            {
                menuNone.Checked = true;
                menuRotation.Checked = false;
                menuShift.Checked = false;
                menuWalk.Checked = false;
                menuBalance.Checked = false;
            }
        }

        private void menuRotation_Click(object sender, EventArgs e)
        {
            if (!menuRotation.Checked)
            {
                menuRotation.Checked = true;
                menuNone.Checked = false;
                menuShift.Checked = false;
                menuWalk.Checked = false;
                menuBalance.Checked = false;
            }
        }

        private void menuWalk_Click(object sender, EventArgs e)
        {
            if (!menuWalk.Checked)
            {
                menuWalk.Checked = true;
                menuRotation.Checked = false;
                menuShift.Checked = false;
                menuNone.Checked = false;
                menuBalance.Checked = false;
            }

        }

        private void menuShift_Click(object sender, EventArgs e)
        {
            if (!menuShift.Checked)
            {
                menuShift.Checked = true;
                menuRotation.Checked = false;
                menuNone.Checked = false;
                menuWalk.Checked = false;
                menuBalance.Checked = false;
            }
        }

        private void menuBalance_Click(object sender, EventArgs e)
        {
            if (!menuBalance.Checked)
            {
                menuBalance.Checked = true;
                menuRotation.Checked = false;
                menuNone.Checked = false;
                menuWalk.Checked = false;
                menuShift.Checked = false;
            }
        }
     
    }
}